//FREESLOTS
freeslot("sfx_kniswg")
freeslot("SPR_LEFD")
freeslot("MT_LEAFY_DED")
freeslot("S_LEAFY_DEAD")
freeslot("S_LEAFY_REST")

//STATES
states[S_LEAFY_DEAD] = {SPR_LEFD, FF_ANIMATE|A, 14, nil, 6, 2, S_LEAFY_REST}
states[S_LEAFY_REST] = {SPR_LEFD, H, 150, nil, 0, 0, S_NULL}

//MOBJINFO
mobjinfo[MT_LEAFY_DED] = {
	doomednum = -1,
	spawnstate = S_LEAFY_DEAD,
	spawnhealth = 1000,
	speed = 0,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY
}

//FUNCTIONS
local function Leafy_PlayerThink(player)
   if not (player.realmo and player.realmo.valid) or (player.spectator) then return end
   if player.leafstomp == nil then player.leafstomp = false end
   if player.knife_cool == nil then player.knife_cool = false end
   if player.flingurself == nil then player.flingurself = false end
   if player.fling_timer == nil then player.fling_timer = 0 end
   if player.frefall == nil then player.frefall = false end
   if player.leafcharge == nil then player.leafcharge = 0 end
   if not (player.realmo.skin == "leafy") then return end
   
   //PLAYING WITH MATH
   //IT MAKES FALLING WAY MORE SLOWER
   //DOES NOT APPLY ON LEAFY STOMP FOR OBVIOUS REASONS
   
   //LAZY...VERY LAZY
   if (player.realmo.momz < 0) and not (player.realmo.eflags & MFE_VERTICALFLIP) and not (player.leafstomp) and not (player.playerstate == PST_DEAD) then -- NORMAL GRAVITY
      player.realmo.momz = ($ - FRACUNIT*3) / 2
   end
   
   if (player.realmo.momz > 0) and (player.realmo.eflags & MFE_VERTICALFLIP) and not (player.leafstomp) and not (player.playerstate == PST_DEAD) then -- REVERSE GRAVITY
      player.realmo.momz = ($ + FRACUNIT*3) / 2
   end
   
   //TAPPING AND ONE ACTIONS
   if not (player.cmd.buttons & BT_CUSTOM2) then
	  player.knife_ready = true
	  player.knife_throwing = false
   elseif player.knife_ready then
	  player.knife_throwing = true
	  player.knife_ready = false
   else
	  player.knife_throwing = false
   end
   
   if player.powers[pw_justsprung] != 0 then
	  player.sprungready = true
	  player.justsprung = false
   elseif player.sprungready then
	  player.justsprung = true
	  player.sprungready = false
   else
	  player.justsprung = false
   end
   
   //MOAR Z MOMENTUM PLZ
   if player.justsprung then
      player.leafstomp = false
      player.realmo.momz = $*2
   end
   
   //COOLDOWN FOR KNIFE THROWING
   //DO NOT SPAM
   if not (leveltime % 35) then
      player.knife_cool = false
   end 
   
   //CHARGE....
   //THEN FLING URSELF
   if not (P_IsObjectOnGround(player.realmo) or P_IsObjectInGoop(player.realmo)) and not (player.flingurself or player.frefall or P_PlayerInPain(player)) then
      if (player.cmd.buttons & BT_CUSTOM3) then
	     if not (player.leafcharge % 10) and (player.leafcharge < 30) then
		    P_SpawnGhostMobj(player.realmo)
			S_StartSound(player.realmo, sfx_kc6c)
		 end
		 
         if (player.leafcharge < 30) then
            player.leafcharge = $ + 1
			player.pflags = $|PF_JUMPSTASIS
	     end
	  end
	  
	  if not (player.cmd.buttons & BT_CUSTOM3) and (player.leafcharge > 0) and not (player.playerstate == PST_DEAD) then
         P_SetObjectMomZ(player.realmo, player.leafcharge * FRACUNIT, false)
	     P_Thrust(player.realmo, player.cmd.angleturn << 16, 50*FRACUNIT)
		 S_StartSound(player.realmo, sfx_wdjump)
	     player.pflags = $|PF_THOKKED|PF_JUMPSTASIS
		 player.leafcharge = 0
		 player.fling_timer = 80
	     player.flingurself = true
	  end
   end
   
   //NOT USABLE ON GROUND OR GOOP, FUCK OFF
   if (P_IsObjectOnGround(player.realmo) or P_IsObjectInGoop(player.realmo)) and (player.flingurself or player.frefall) then
      player.leafcharge = 0
      player.normalspeed = skins[player.realmo.skin].normalspeed
      player.flingurself = false
	  player.frefall = false
	  player.fling_timer = 0
	  player.realmo.spriteroll = 0
   end
   
   //SPIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIN
   if player.flingurself then
      player.realmo.spriteroll = $ + ANG20
	  player.pflags = $|PF_JUMPSTASIS
	  player.fling_timer = $ - 1
      P_SpawnGhostMobj(player.realmo)
	  if ((player.realmo.momz < 0) and not (player.realmo.eflags & MFE_VERTICALFLIP)) or ((player.realmo.momz > 0) and (player.realmo.eflags & MFE_VERTICALFLIP)) then
	     player.frefall = true
		 player.realmo.spriteroll = 0
		 player.fling_timer = 0
		 player.pflags = $|PF_JUMPSTASIS
		 player.flingurself = false
	  end
   end
   
   //FALL LIKE A LEAF
   //IT'S JUST A SPEED BOOST
   if (player.frefall) then
      player.pflags = $|PF_JUMPSTASIS
      player.normalspeed = 80*FRACUNIT
	  if (player.cmd.buttons & BT_SPIN) and not (player.leafstomp) then
	     S_StartSound(player.realmo, sfx_rail1)
	     player.leafstomp = true
	     player.frefall = false
	  end
   end
   
   //STOMPPPPPP
   if (player.leafstomp) then
      //I HATE GRAVITY
      if (player.realmo.eflags & MFE_VERTICALFLIP) then
         player.realmo.momz = $ + FRACUNIT*2
	  else
	     player.realmo.momz = $ - FRACUNIT*2
	  end
	  
	  //stop
	  if (P_IsObjectOnGround(player.realmo) or P_IsObjectInGoop(player.realmo)) then
	     S_StartSound(player.realmo, sfx_rail2)
		 player.normalspeed = skins[player.realmo.skin].normalspeed
	     player.leafstomp = false
	  end
   end
   
   
   //KNIFE THROW
   if (player.knife_throwing and not player.knife_cool) then
      P_SPMAngle(player.realmo, MT_BFDI_KNIFE, player.realmo.angle + ANGLE_45, 1) --YES
      P_SPMAngle(player.realmo, MT_BFDI_KNIFE, player.realmo.angle + ANG20, 1) -- THIS
      P_SPMAngle(player.realmo, MT_BFDI_KNIFE, player.realmo.angle, 1) -- IS
	  P_SPMAngle(player.realmo, MT_BFDI_KNIFE, player.realmo.angle - ANG20, 1) -- A
	  P_SPMAngle(player.realmo, MT_BFDI_KNIFE, player.realmo.angle - ANGLE_45, 1) -- HALF-CIRCLE
	  S_StartSound(player.realmo, sfx_kniswg)
	  local lilghost = P_SpawnGhostMobj(player.realmo)
	  if (lilghost and lilghost.valid) then
	     lilghost.colorized = true
		 lilghost.color = player.skincolor
	  end
	  player.knife_cool = true
   end
   
   //CUSTOM DEATH
   if (player.playerstate == PST_DEAD) then
      if (P_IsObjectOnGround(player.realmo) or P_IsObjectInGoop(player.realmo)) and not (player.realmo.leafyded and player.realmo.leafyded.valid) then
	     player.realmo.leafyded = P_SpawnMobj(player.realmo.x, player.realmo.y, player.realmo.z, MT_LEAFY_DED)
		 player.realmo.leafyded.color = player.skincolor
		 player.realmo.leafyded.spritexscale = FRACUNIT/3
		 player.realmo.leafyded.spriteyscale = FRACUNIT/3
		 player.realmo.flags = $|MF_NOGRAVITY
	     player.realmo.momz = 0
	     player.realmo.sprite = SPR_NULL
	  end
	  
	  player.normalspeed = skins[player.realmo.skin].normalspeed
      player.leafcharge = 0
   end
   
   if (P_IsObjectOnGround(player.realmo) or P_IsObjectInGoop(player.realmo)) and (player.leafcharge > 0) then
      player.leafcharge = 0
   end
end

//HOOKS
addHook("PlayerThink", Leafy_PlayerThink)